LeetCode Q209 Minimum Size Subarray Sum | Lei Jiang Coding


LeetCode Q209 Minimum Size Subarray Sum | Lei Jiang Coding
Given an array of n positive integers and a positive integer s, find the minimal length of a subarray of which the sum ≥ s. If there isn't one, return 0 instead.
For example, given the array [2,3,1,2,4,3] and s = 7,
the subarray [4,3] has the minimal length under the problem constraint.

https://leetcode.com/discuss/35378/solutions-java-with-time-complexity-nlogn-with-explanation
https://leetcode.com/discuss/35626/java-solution-o-n-time-sliding-window
I think in the initialization, min should be nums.length+1 instead of nums.length.
And at last, instead of
if(min == nums.length)return 0;
it should be
if(min == nums.length+1) return 0;
private int solveN(int s, int[] nums) { int start = 0, end = 0, sum = 0, minLen = Integer.MAX_VALUE; while (end < nums.length) { while (end < nums.length && sum < s) sum += nums[end++]; if (sum < s) break; while (start < end && sum >= s) sum -= nums[start++]; if (end - start + 1 < minLen) minLen = end - start + 1; } return minLen == Integer.MAX_VALUE ? 0 : minLen; }
public int minSubArrayLen(int s, int[] a) { if (a == null || a.length == 0) return 0; int i = 0, j = 0, sum = 0, min = Integer.MAX_VALUE; while (j < a.length) { sum += a[j++]; while (sum >= s) { min = Math.min(min, j - i); sum -= a[i++]; } } return min == Integer.MAX_VALUE ? 0 : min; }
http://segmentfault.com/a/1190000003922961
我们用两个指针维护一个窗口,保证这个窗口的内的和是小于目标数的。如果新来的数加上后,和大于目标,则比较下当前窗口长度和最短窗口长度,窗口左边界右移。如果和仍小于目标数,则将窗口右边界右移。注意这里退出的条件,右边界是小于等于长度,因为我们窗口到了最右侧时,还需要继续左移左边界来看有没有更优的解法。另外,如果左边界大于右边界时,说明最短子串的长度已经小于等于1,我们就不用再查找了。
    public int minSubArrayLen(int s, int[] nums) {
        if(nums.length == 0) return 0;
        int left = 0, right = 0, sum = 0, minLen = nums.length + 1;
        while(right <= nums.length && left <= right){
            if(sum < s){
                // 当右边界等于长度时,我们要多等一轮,等待左边界左移,这时候不能加
                if(right < nums.length){
                    sum += nums[right];
                }
                right++;
            } else {
                // 当和大于等于目标时,检查长度并左移边界
                minLen = Math.min(minLen, right - left);
                sum -= nums[left];
                left++;
            }
        }
        return minLen <= nums.length ? minLen : 0;
    }
http://zwzbill8.blogspot.com/2015/05/leetcode-minimum-size-subarray-sum.html
X. Slide Window
   public int minSubArrayLen(int s, int[] nums) {
        if (nums.length == 0) {
            return 0;
        }
        
        int totalSum = 0;
        for (int num : nums) {
            totalSum += num;
        }
        if (totalSum < s) {
            return 0;
        }
        
        int i = 0;
        int j = 0;
        int currSum = nums[0];
        int minLen = nums.length;
        while (i < nums.length) {
            if (currSum >= s) {
                if (minLen > j - i + 1) {
                    minLen = j - i + 1;
                }
                currSum -= nums[i];
                i++;
            } else {
                j++;
                if (j >= nums.length) {
                    break;
                }
                currSum += nums[j];
            }
        }
        return minLen;
    }
X. Prefix Sum + Binary Search
O(n log n) running time, and extra O(n) space.
We first compute all the prefix sums, where prefixSum[i] denotes the sum of the first i integers, i >= 0. Under this notation, the index for the prefixSum array ranges from 0 to n.
Next, for each index i, we find the minimum length of a subarray starting from i + 1 (inclusive) of which the sum >= s, using binary search. Hence, the overall running time is O(n log n). 
Remarks: A slight improvement in terms of performance will be narrowing down the range of the binary search even further. Instead of searching from i to end, one can search from j to end, where j > i. One needs to change the following binarySearch() function signature to incorporate this improvement.
    private int binarySearch(int i, int s, int[] prefixSum) {
        int low = i;
        int high = prefixSum.length - 1;
        while (low <= high) {
            int mid = low + (high - low) / 2;
            if (prefixSum[mid] - prefixSum[i] < s) {
                low = mid + 1;
            } else {
                if (
                    mid > 0 && 
                    prefixSum[mid - 1] - prefixSum[i] < s
                ) {
                    return mid - i;
                }
                high = mid - 1;
            }
        }
        return prefixSum.length;
    }
    
    public int minSubArrayLen(int s, int[] nums) {
        if (nums.length == 0) {
            return 0;
        }
        
        int[] prefixSum = new int[nums.length + 1];
        int totalSum = buildPrefixSum(nums, prefixSum);
        if (totalSum < s) {
            return 0;
        }
        
        int minLen = prefixSum.length - 1;
        for (int i = 0; i < prefixSum.length; i++) {
            int len = binarySearch(i, s, prefixSum);
            if (minLen > len) {
                minLen = len;
            }
        }
        return minLen;
    }


public int minSubArrayLenBinarySearch(int s, int[] nums) {
    if (null == nums || nums.length == 0) {
        return 0;
    }
    int min = nums.length + 1;
    int[] sum = new int[nums.length + 1];
    for (int i = 0; i < nums.length; i++) {
        sum[i + 1] = sum[i] + nums[i];
        if (sum[i + 1] >= s) {
            int left = binarySearch(sum, sum[i + 1] - s, 0, i + 1);
            min = Math.min(min, i + 1 - left);
        }
    }
    return min == nums.length + 1 ? 0 : min;
}
private int binarySearch(int[] nums, int target, int start, int end) {
    while (start + 1 < end) {
        int mid = start + (end - start) / 2;
        if (nums[mid] >= target) {
            end = mid;
        } else {
            start = mid;
        }
    }
    if (nums[end] <= target) {
        return end;
    } else {
        return start;
    }
}
X. O(n) running time, and extra O(n) space.We first compute all the prefix sums, where prefixSum[i] denotes the sum of the first i integers, i >= 0. Under this notation, the index for the prefixSum array ranges from 0 to n.
Next, we move two pointers i and j. For each i, we find the minimum length of a subarraystarting from i + 1 (inclusive) of which the sum >= s. The key observation is that j is non-decreasing, which implies an algorithm with O(n) running time.
    private int buildPrefixSum(int[] nums, int[] prefixSum) {
        prefixSum[0] = 0;
        for (int i = 0; i < nums.length; i++) {
            prefixSum[i + 1] = prefixSum[i] + nums[i];
        }
        return prefixSum[nums.length];
    }
    
    private int twoPointerIncrementalSearch(
        int s, 
        int[] prefixSum
    ) {
        int minLen = prefixSum.length - 1;
        int i = 0;
        int j = 1;
        while (
            i < prefixSum.length - 1 
            && j < prefixSum.length
        ) {
            if (prefixSum[j] - prefixSum[i] < s) {
                j++;
            } else {
                if (minLen > j - i) {
                    minLen = j - i;
                } 
                i++;
            }
        }
        return minLen;
    }
    
    public int minSubArrayLen(int s, int[] nums) {
        if (nums.length == 0) {
            return 0;
        }
        
        int[] prefixSum = new int[nums.length + 1];
        int totalSum = buildPrefixSum(nums, prefixSum);
        if (totalSum < s) {
            return 0;
        }
        
        return twoPointerIncrementalSearch(s, prefixSum);
    }
http://www.jyuan92.com/blog/leetcode-minimum-size-subarray-sum/
When meet some problem, which required to check / get the sub-continuous-array or sub-continuous-string, we should always think about Slide Window Algorithm.
Using two pointers, initial to the zero index.
  • When the sum is smaller than s, which means that we should move the right pointer to the next index.
  • When the sum is larger or equal than s, which means the sum of subarray between left and right satisfied the requirement. the right - left + 1 maybe the result. Check for the result, and move left pointers to the next index.
  • We should always be careful about the edge case
    • there isn’t exist a subarray which the sum will larger than s
    • When right reach the last index of array, the left index should still keep moving if the sum is larger than s. But when stop?!
    • When there exist an element which is equal or larger than s.
  • Time Complexity: O(n)
The best solution is below, and we should keep in mind this solution as an template.
public int minSubArrayLenImprove(int s, int[] nums) {
    if (null == nums || nums.length == 0) {
        return 0;
    }
    int left = 0;
    int right = 0;
    int min = nums.length + 1;
    int sum = 0;
    while (right < nums.length) {
        sum += nums[right];
        while (sum >= s) {
            min = Math.min(min, right - left + 1);
            sum -= nums[left];
            left++;
        }
        right++;
    }
    return min == nums.length + 1 ? 0 : min;
}

public int minSubArrayLen(int s, int[] nums) {
    if (null == nums || nums.length == 0) {
        return 0;
    }
    int left = 0;
    int right = 0;
    int sum = nums[0];
    int minLength = Integer.MAX_VALUE;
    while (right < nums.length) {
        if (sum >= s) {
            minLength = Math.min(minLength, right - left + 1);
            sum -= nums[left];
            left++;
        } else {
            if (right == nums.length - 1) {
                return minLength == Integer.MAX_VALUE ? 0 : minLength;
            }
            right++;
            sum += nums[right];
        }
    }
    return minLength;
}
Another O(NLogN) solution that first calculate cumulative sum and then for each starting point binary search for end position. This uses O(N) space
public int minSubArrayLen(int s, int[] nums) { int sum = 0, min = Integer.MAX_VALUE; int[] sums = new int[nums.length]; for (int i = 0; i < nums.length; i++) sums[i] = nums[i] + (i == 0 ? 0 : sums[i - 1]); for (int i = 0; i < nums.length; i++) { int j = findWindowEnd(i, sums, s); if (j == nums.length) break; min = Math.min(j - i + 1, min); } return min == Integer.MAX_VALUE ? 0 : min; } private int findWindowEnd(int start, int[] sums, int s) { int i = start, j = sums.length - 1, offset = start == 0 ? 0 : sums[start - 1]; while (i <= j) { int m = (i + j) / 2; int sum = sums[m] - offset; if (sum >= s) j = m - 1; else i = m + 1; } return i; }

X. https://leetcode.com/discuss/63385/o-n-o-nlogn-solutions-both-o-1-space
O(NLogN) - search if a window of size k exists that satisfy the condition
public class Solution {
    public int minSubArrayLen(int s, int[] nums) {
        int i = 1, j = nums.length, min = 0;
        while (i <= j) {
            int mid = (i + j) / 2;
            if (windowExist(mid, nums, s)) {
                j = mid - 1;
                min = mid;
            } else i = mid + 1;
        }
        return min;
    }


    private boolean windowExist(int size, int[] nums, int s) {
        int sum = 0;
        for (int i = 0; i < nums.length; i++) {
            if (i >= size) sum -= nums[i - size];
            sum += nums[i];
            if (sum >= s) return true;
        }
        return false;
    }
}

http://www.programcreek.com/2014/05/leetcode-minimum-size-subarray-sum-java/
    for(int j=0; j<nums.length; ){ ==> not good
http://shibaili.blogspot.com/2015/06/day-107-minimum-size-subarray-sum.html
Read full article from LeetCode Q209 Minimum Size Subarray Sum | Lei Jiang Coding

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts